import {
  passwordInput,
  passwordConfirmInput,
  passwordCheck,
} from "./domelements";

const [
  passwordLength,
  passwordLowercase,
  passwordUppercase,
  passwordNumber,
  passwordSpecial,
  passwordMatch,
] = passwordCheck.children;

function checkPasswordMatch() {
  if (
    passwordInput.value !== passwordConfirmInput.value ||
    passwordInput.value === ""
  ) {
    passwordMatch.style.backgroundColor = "";
    return false;
  }
  passwordMatch.style.backgroundColor = "#4b4";
  return true;
}

function checkPasswordRequirement(e, regex, element) {
  if (e.value.search(regex) >= 0) {
    element.style.backgroundColor = "#4b4";
    return true;
  }
  element.style.backgroundColor = "";
  return false;
}

function checkPasswordValidity() {
  const length = passwordInput.value.length >= 8;
  if (length) {
    passwordLength.style.backgroundColor = "#4b4";
  } else {
    passwordLength.style.backgroundColor = "";
  }
  const lowercase = checkPasswordRequirement(
    passwordInput,
    /[a-z]/,
    passwordLowercase,
  );
  const uppercase = checkPasswordRequirement(
    passwordInput,
    /[A-Z]/,
    passwordUppercase,
  );
  const number = checkPasswordRequirement(passwordInput, /\d/, passwordNumber);
  const special = checkPasswordRequirement(
    passwordInput,
    /[#?!@$%^&*-]/,
    passwordSpecial,
  );
  return length && lowercase && uppercase && number && special;
}

export { checkPasswordValidity, checkPasswordMatch };
